package ueb081konfetti;

import java.util.ArrayList;

import processing.core.PApplet;


@SuppressWarnings("serial")
public class Ueb081Konfetti extends PApplet {
	
	private ArrayList<konfetti> konfettis;
	private final float konfettiMaxSize = 100;
	
	private int konfettiCount = 0;
	private final int maxKonfettiCount = 1000; 
	

	public void setup() {
		  size(600, 600);   // frame size
		  
		  smooth();         // use anti-aliasing
		  //frameRate(60);     // 20 frames per sec
		  
		  noStroke();
		  colorMode(RGB);
		  background(255);    // white
		  
		  konfettis = new ArrayList<konfetti>();
		  
	}

	public void draw() {
		addKonfetti();
		
		drawKonfetti();
	}
	
	
	public void mousePressed() {
		  clearKonfetti();
		}

	
	private void drawKonfetti() {
		background(255);    // white
		
		for (konfetti currKonfetti : konfettis) {
					
			  fill(currKonfetti.getColor(), (255.0f / height * mouseY));
			  
			  ellipse(currKonfetti.getX(), currKonfetti.getY(), currKonfetti.getSize(), currKonfetti.getSize());
		}
	}
	
	private void clearKonfetti() {
			konfettis.clear();
			konfettiCount = 0;
	}
	
	
	private void addKonfetti() {
		if (konfettiCount >= maxKonfettiCount) {
			clearKonfetti();
		}
		
		konfettis.add(new konfetti(
				(int)random(width),
				(int)random(height),
				color(random(255), random(255), random(255)),
				 (int)(konfettiMaxSize / width * mouseX)));
		konfettiCount++;
	}
	
}
